SystemOrganization addCategory: 'OrbeonBizagiReader2'!

Object subclass: #XPDLObject2
	instanceVariableNames: 'xmlSegment attributes xmlString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLObject2 subclass: #XPDLActivityNode
	instanceVariableNames: 'inTransitions outTransitions loopType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:32'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:32'!
inTransitions
	^inTransitions! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:32'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:32'!
loopType
	^loopType! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:32'!
loopType: newValue
	loopType := newValue! !

!XPDLActivityNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:32'!
outTransitions
	^outTransitions! !

!XPDLActivityNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:32'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:10'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[',self getName, ']'.! !

!XPDLActivityNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:32'!
setLoopTypeWithNode: xmlNode
	"The receiver set it's loop type from the xml node <xmlNode>
	Loop type: (none) (standart) (multi-instance)"
	| loopNode |

	loopNode := xmlNode findElementNamed: 'Loop'.
	loopNode ifNil: [^self].

	^self loopType: (loopNode attributeAt: 'LoopType')! !

XPDLActivityNode subclass: #XPDLSubProcessNode
	instanceVariableNames: 'subProcess subProcessId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:15'!
isSubProcessNode

	^true! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:37'!
setParentProcessDataWithNode: xmlNode
	"Set the <id> of the Subprocess of the receiver. The receiver will go to this subprocess when executed"

	self subProcessId: ((xmlNode findElementNamed: 'SubFlow') attributeAt: 'Id')! !

!XPDLSubProcessNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:04'!
shortType

	^'Sub'! !

!XPDLSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcess
	^subProcess! !

!XPDLSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcess: newValue
	subProcess := newValue! !

!XPDLSubProcessNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcessId
	^subProcessId! !

!XPDLSubProcessNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 08:21'!
subProcessId: newValue
	subProcessId := newValue! !

XPDLActivityNode subclass: #XPDLTaskNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLTaskNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:14'!
isTaskNode

	^true! !

!XPDLTaskNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:07'!
shortType

	^'F'! !

XPDLObject2 subclass: #XPDLEventNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLEventNode subclass: #XPDLEndNode
	instanceVariableNames: 'inTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:02'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.! !

!XPDLEndNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:43'!
inTransitions
	^inTransitions! !

!XPDLEndNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:43'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:43'!
isEndNode

	^true! !

!XPDLEndNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:04'!
shortType

	^'E'! !

XPDLEventNode subclass: #XPDLStartNode
	instanceVariableNames: 'outTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/24/2015 17:02'!
initialize

	super initialize.

	outTransitions := OrderedCollection new.! !

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:43'!
isStartNode

	^true! !

!XPDLStartNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:43'!
outTransitions
	^outTransitions! !

!XPDLStartNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:43'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLStartNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:03'!
shortType

	^'Str'! !

XPDLObject2 subclass: #XPDLGatewayNode
	instanceVariableNames: 'inTransitions outTransitions type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
initialize

	super initialize.

	inTransitions := OrderedCollection new.
	outTransitions := OrderedCollection new.! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
inTransitions
	^inTransitions! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
inTransitions: newValue
	inTransitions := newValue! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
isGatewayNode

	^true! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
outTransitions
	^outTransitions! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
outTransitions: newValue
	outTransitions := newValue! !

!XPDLGatewayNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
shortType

	^'G'! !

!XPDLGatewayNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
type
	^type! !

!XPDLGatewayNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
type: newValue
	type := newValue! !

XPDLObject2 subclass: #XPDLLaneNode
	instanceVariableNames: 'xpdlObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:31'!
addAllXpdlObject: aCollection

	^xpdlObjects addAll: aCollection! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:12'!
addXpdlObject: aXPDLObject

	^xpdlObjects add: aXPDLObject! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
getAnyObjectNamed: aString ifNone: aBlock

	^xpdlObjects detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
initialize

	super initialize.

	xpdlObjects := OrderedCollection new.! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
rectangle

	^Rectangle origin: (self valueOf: 'x') @ (self valueOf: 'y') extent: (self valueOf: 'width') @ (self valueOf: 'height')! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
rectangleIncludesActivity: aXPDLObject

	^self rectangle containsPoint: aXPDLObject originPoint! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:36'!
setGraphicLaneValues

	self setGraphicLaneValuesWithNode: xmlSegment! !

!XPDLLaneNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
setGraphicLaneValuesWithNode: xmlLaneNode
	"We set the graphic information of <newLane> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlLaneNode findElementNamed: 'NodeGraphicsInfo'.
	self set: 'width' value: (Number readFrom: (gNode attributeAt: 'Width')).
	self set: 'height' value: (Number readFrom: (gNode attributeAt: 'Height')).

	gNode := xmlLaneNode findElementNamed: 'Coordinates'.
	self set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	self set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLLaneNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
xpdlObjects
	^xpdlObjects! !

!XPDLLaneNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
xpdlObjects: newValue
	xpdlObjects := newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
addInTransition: aXPDLTransitionNode

	^self inTransitions add: aXPDLTransitionNode! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
addOutTransition: aXPDLTransitionNode

	^self outTransitions add: aXPDLTransitionNode! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
attributes

   "Return the value of the instance variable 'attributes'."
   ^attributes! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
attributes: newValue

   "Modify the value of the instance variable 'attributes'."
   attributes := newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
getId

	^self valueOf: 'id'! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
getName

	^self valueOf: 'name'! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
id: newValue

   "Modify the value of the instance variable 'id'."
	self set: 'id' value: newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
initialize

	super initialize.

	attributes := Dictionary new.! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
inTransitions

	^OrderedCollection new! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
isEndNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
isGatewayNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
isStartNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
isSubProcessNode

	^false! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
isTaskNode

	^false! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
name: newValue

   "Modify the value of the instance variable 'name'."

	self set: 'name' value: newValue! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
originPoint

	^(self valueOf: 'x') @ (self valueOf: 'y')! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
outTransitions

	^OrderedCollection new! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
removeAttribute: attrName 

	^attributes removeKey: attrName ifAbsent: []! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
set: attrName value: anObject

	^attributes at: attrName put: anObject! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:28'!
setGraphicActivityValuesWithNode: xmlNode
	"We set the graphic information of <newActivity> using the XML node <xmlNode>"
	| gNode |

	gNode := xmlNode findElementNamed: 'Coordinates'.
	self set: 'x' value: (Number readFrom: (gNode attributeAt: 'XCoordinate')).
	self set: 'y' value: (Number readFrom: (gNode attributeAt: 'YCoordinate')).! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:26'!
setLoopTypeWithNode: xmlNode
	"The receiver set it's loop type from the xml node <xmlNode>
	Loop type: (none) (standart) (multi-instance)"! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 08:20'!
setParentProcessDataWithNode: xmlNode! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
shortType

	^'xpdl'! !

!XPDLObject2 methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:30'!
valueOf: attrName

	^attributes at: attrName ifAbsent: [nil]! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
xmlSegment
	^xmlSegment! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
xmlSegment: newValue
	xmlSegment := newValue! !

!XPDLObject2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:30'!
xmlString

   "Return the value of the instance variable 'xmlString'."
   ^xmlString! !

!XPDLObject2 methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:30'!
xmlString: newValue

   "Modify the value of the instance variable 'xmlString'."
   xmlString := newValue! !

XPDLObject2 subclass: #XPDLPoolNode
	instanceVariableNames: 'lanes processId workflow workflowId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:29'!
activities

	^workflow activities! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 20:34'!
addLane: aXPDLLaneNode

	^lanes at: aXPDLLaneNode getName put: aXPDLLaneNode! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:42'!
createLanes

	^self createLanesFrom: xmlSegment! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:42'!
createLanesFrom: aXMLDocument

	aXMLDocument allElementsNamed: 'Lane' do: [:xmlLaneNode | | newLane |
		newLane := XPDLLaneNode new 
								xmlSegment: xmlLaneNode;
								id: (xmlLaneNode attributeAt: 'Id');
								name: (xmlLaneNode attributeAt: 'Name');
								yourself.
		newLane setGraphicLaneValues.

		self addLane: newLane.].

	^lanes! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 20:34'!
createWorkflowFrom: aXMLDocument

	aXMLDocument allElementsNamed: 'WorkflowProcess' do: [:xmlWorkflow | | newWorkflow |
		((xmlWorkflow attributeAt: 'Id') = workflowId)
		ifTrue: [newWorkflow := XPDLWorkflowProcess new 
								xmlSegment: xmlWorkflow;
								id: (xmlWorkflow attributeAt: 'Id');
								name: (xmlWorkflow attributeAt: 'Name');
								yourself.
					newWorkflow 
						createActivityNodes;
						createTransitionNodes;
						setStartAndEndNodes;
						connectActivitiesToParentLane;
						connectActivitiesAndTrasitions.
					self workflow: newWorkflow.
		].
	].

	^lanes! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:10'!
getLaneNamed: aString ifNone: aBlock

	^lanes at: aString ifPresent: [:value | value] ifAbsent: aBlock! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 20:34'!
initialize

	super initialize.

	lanes := Dictionary new.! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:42'!
lanes
	^lanes! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:42'!
lanes: newValue
	lanes := newValue! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:43'!
processId
	^processId! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:43'!
processId: newValue
	processId := newValue! !

!XPDLPoolNode methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:31'!
setLanesComponents
	| activities |

	activities := self activities.

	lanes do: [:eachLane | 
		eachLane addAllXpdlObject: (activities select: [:eachAct | eachLane rectangleIncludesActivity: eachAct])]! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:43'!
workflow
	^workflow! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:43'!
workflow: newValue
	workflow := newValue! !

!XPDLPoolNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:43'!
workflowId
	^workflowId! !

!XPDLPoolNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:43'!
workflowId: newValue
	workflowId := newValue! !

XPDLObject2 subclass: #XPDLTransitionNode
	instanceVariableNames: 'startNode endNode startId endId startCondition expectedResult transitionPreviousFields roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
endId
	^endId! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
endId: newValue
	endId := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
endNode
	^endNode! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
endNode: newValue
	endNode := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
expectedResult
	^expectedResult! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
expectedResult: newValue
	expectedResult := newValue! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:41'!
initialize

	super initialize.

	roles := OrderedCollection new.! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 10:06'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: '[(',startNode shortType, ')', startNode getName, '>>', endNode getName, '(', endNode shortType, ')]'.! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 20:04'!
setExtendedAttributes

	^self setExtendedAttributesWithNode: xmlSegment! !

!XPDLTransitionNode methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 09:40'!
setExtendedAttributesWithNode: xmlNode
	"The receiver set the extended attributes <expectedResult> and <transitionPreviousFields> supported by the Process Engine"

	xmlNode allElementsNamed: 'ExtendedAttribute' do: [:eachAttr |
		((eachAttr attributeAt: 'Name') = 'expectedResult')  "-extended attribute- a TextArea in Bizagi Modeler (value is a XML)"
		ifTrue: [self expectedResult: (XMLDOMParser parse: (eachAttr attributeAt: 'Value')) contentString].

		((eachAttr attributeAt: 'Name') = 'transitionPreviousFields') 
		ifTrue: [self transitionPreviousFields: (eachAttr attributeAt: 'Value')]."-extended attribute- a TextBox in Bizagi Modeler (value is a string)"
	].! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
startCondition
	^startCondition! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
startCondition: newValue
	startCondition := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
startId
	^startId! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
startId: newValue
	startId := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
startNode
	^startNode! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
startNode: newValue
	startNode := newValue! !

!XPDLTransitionNode methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 09:40'!
transitionPreviousFields
	^transitionPreviousFields! !

!XPDLTransitionNode methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 09:40'!
transitionPreviousFields: newValue
	transitionPreviousFields := newValue! !

XPDLObject2 subclass: #XPDLWorkflowProcess
	instanceVariableNames: 'parentPool startNode endNodes lanes activities transitions processId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:46'!
activities
	^activities! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:46'!
activities: newValue
	activities := newValue! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 10/25/2015 19:47'!
addActivity: activityEventGateway

	^activities at: activityEventGateway getName put: activityEventGateway! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 10/25/2015 19:47'!
addTransition: aXPDLLaneNode

	^transitions add: aXPDLLaneNode! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 10/25/2015 19:47'!
connectActivitiesAndTrasitions

	self transitions do: [:eachTr | "connect transition start and end node with XPLDActivities"
		eachTr startNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr startId] ifNone: [nil]).
		eachTr endNode: 
				(activities detect: [:eachAct | eachAct getId = eachTr endId] ifNone: [nil]).
		eachTr startNode addOutTransition: eachTr.
		eachTr endNode addInTransition: eachTr.].! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 10/25/2015 19:47'!
connectActivitiesToParentLane

	self lanes do: [:eachLane | "set the role of each transition -each activity inTransitions-"
		eachLane xpdlObjects: (self activities select: [:eachAct | eachLane rectangleIncludesActivity: eachAct]).
		eachLane xpdlObjects do: [:eachAct | 
			eachAct inTransitions do: [:eachTr | eachTr roles: (OrderedCollection with: eachLane getName)]]].! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 10/25/2015 19:59'!
createActivityNodes

	^self createActivityNodesFrom: xmlSegment! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 10/25/2015 19:58'!
createActivityNodesFrom: aXMLDocument

	aXMLDocument allElementsNamed: 'Activity' do: [:eachNode | | newActivity |
		newActivity := (self getActivityInstanceFrom: eachNode)
			id: (eachNode attributeAt: 'Id');
			name: (eachNode attributeAt: 'Name');
			xmlString: eachNode; "remove this later"
			yourself.
		newActivity 
			setLoopTypeWithNode: eachNode; "loop type: (none) (standart) (multi-instance) [only for Tasks and Subprocess nodes ]"
			setGraphicActivityValuesWithNode: eachNode; "set graphic coordinates [for all nodes]"
			setParentProcessDataWithNode: eachNode. "set the Id of the subprocess [only for Subprocess nodes]"

		self addActivity: newActivity.].

	^activities! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 10/25/2015 20:03'!
createTransitionNodes

	^self createTransitionNodesFrom: xmlSegment! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 10/25/2015 20:04'!
createTransitionNodesFrom: aXMLDocument

	aXMLDocument allElementsNamed: 'Transition' do: [:eachNode | | newTransition startCond |
		startCond := eachNode findElementNamed: 'Expression'.
		startCond ifNotNil: [startCond := startCond contentString].
		newTransition := XPDLTransitionNode new 
									xmlSegment: eachNode;
									id: (eachNode attributeAt: 'Id');
									name: (eachNode attributeAt: 'Name');
									startId: (eachNode attributeAt: 'From');
									endId: (eachNode attributeAt: 'To');
									startCondition: startCond;
									yourself.
		newTransition setExtendedAttributes.
		self addTransition: newTransition.].

	^transitions! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:46'!
endNodes
	^endNodes! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:46'!
endNodes: newValue
	endNodes := newValue! !

!XPDLWorkflowProcess methodsFor: 'components creation' stamp: 'BrunoBB 10/25/2015 20:10'!
getActivityInstanceFrom: xmlActivityNode

	(xmlActivityNode findElementNamed: 'SubFlow') ifNotNil: [^XPDLSubProcessNode new].

	(xmlActivityNode findElementNamed: 'Route') 
	ifNotNil: [:node | | gate type | 
		gate := XPDLGatewayNode new.
		type := node attributeAt: 'GatewayType' ifAbsent: ['']. "set the type of the gateway"
		^gate type: type].

	(xmlActivityNode findElementNamed: 'StartEvent') ifNotNil: [^XPDLStartNode new].

	(xmlActivityNode findElementNamed: 'EndEvent') ifNotNil: [^XPDLEndNode new].

	^XPDLTaskNode new! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getAnyObjectNamed: aString ifNone: aBlock

	^self getTaskNamed: aString
			ifNone: [self getGatewayNamed: aString 
				ifNone: [self getSubprocessNamed: aString
					ifNone: [self getEndNodeNamed: aString ifNone: [nil]]]]! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getEndNodeNamed: aString ifNone: aBlock

	^endNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getGatewayNamed: aString ifNone: aBlock

	^self getGatewayNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getGatewayNodes

	^activities select: [:each | each isGatewayNode]! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getLaneNamed: aString ifNone: aBlock

	^lanes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getSubprocessNamed: aString ifNone: aBlock

	^self getSubProcessNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getSubProcessNodes

	^activities select: [:each | each isSubProcessNode]! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getTaskNamed: aString ifNone: aBlock

	^self getTaskNodes detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getTaskNodes

	^activities select: [:each | each isTaskNode]! !

!XPDLWorkflowProcess methodsFor: 'searching' stamp: 'BrunoBB 10/25/2015 19:48'!
getTransitionNamed: aString ifNone: aBlock

	^transitions detect: [:each | each getName = aString] ifNone: aBlock! !

!XPDLWorkflowProcess methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 19:46'!
initialize

	super initialize.

	activities := Dictionary new.
	lanes := Dictionary new.
	transitions := OrderedCollection new.
	endNodes := OrderedCollection new.! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:46'!
lanes
	^lanes! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:46'!
lanes: newValue
	lanes := newValue! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:46'!
parentPool
	^parentPool! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:46'!
parentPool: newValue
	parentPool := newValue! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:46'!
processId
	^processId! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:46'!
processId: newValue
	processId := newValue! !

!XPDLWorkflowProcess methodsFor: 'connecting' stamp: 'BrunoBB 10/25/2015 19:47'!
setStartAndEndNodes

	startNode := activities detect: [:each | each isStartNode].

	endNodes := activities select: [:each | each isEndNode].! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:46'!
startNode
	^startNode! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:46'!
startNode: newValue
	startNode := newValue! !

!XPDLWorkflowProcess methodsFor: 'Accessing' stamp: 'BrunoBB 10/25/2015 19:46'!
transitions
	^transitions! !

!XPDLWorkflowProcess methodsFor: 'Updating' stamp: 'BrunoBB 10/25/2015 19:46'!
transitions: newValue
	transitions := newValue! !

Object subclass: #XPDLProcessTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLProcessTemplate class methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 16:58'!
xpdlExample_ProcessFixIssue

^'<?xml version="1.0" encoding="utf-8"?>
<Package xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" Id="0021eafb-ce63-4827-95a8-99ed5cb45b56" Name="fix-issue" xmlns="http://www.wfmc.org/2009/XPDL2.2">
  <PackageHeader>
    <XPDLVersion>2.2</XPDLVersion>
    <Vendor>Bizagi Process Modeler.</Vendor>
    <Created>2015-10-10T17:38:38.3889014-03:00</Created>
    <ModificationDate>2015-10-24T16:31:41.6507681-03:00</ModificationDate>
    <Description>fix-issue</Description>
    <Documentation />
  </PackageHeader>
  <RedefinableHeader>
    <Author>Usuario</Author>
    <Version>1.0</Version>
    <Countrykey>CO</Countrykey>
  </RedefinableHeader>
  <ExternalPackages />
  <Pools>
    <Pool Id="2c171c41-a6aa-4f6e-a4f8-3faa2643d531" Name="Main Process" Process="4d900569-414f-48f1-9698-ba54a5c0bb96" BoundaryVisible="false">
      <Lanes />
      <NodeGraphicsInfos>
        <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="350" Width="700" BorderColor="-16777216" FillColor="-1">
          <Coordinates XCoordinate="30" YCoordinate="30" />
        </NodeGraphicsInfo>
      </NodeGraphicsInfos>
    </Pool>
    <Pool Id="7904a971-b4f0-4f66-9729-b5caff198eec" Name="fix-issue" Process="0f193f2e-eea8-4702-a3a9-f31ab3198aa3" BoundaryVisible="true">
      <Lanes>
        <Lane Id="f59dfcaa-4364-486a-b5c3-1523a2fa314c" Name="developer" ParentPool="7904a971-b4f0-4f66-9729-b5caff198eec">
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="273" Width="650" BorderColor="-11513776" FillColor="-1">
              <Coordinates XCoordinate="50" YCoordinate="0" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Lane>
      </Lanes>
      <NodeGraphicsInfos>
        <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="273" Width="700" BorderColor="-16777216" FillColor="-1">
          <Coordinates XCoordinate="30" YCoordinate="30" />
        </NodeGraphicsInfo>
      </NodeGraphicsInfos>
    </Pool>
  </Pools>
  <Associations />
  <Artifacts />
  <WorkflowProcesses>
    <WorkflowProcess Id="4d900569-414f-48f1-9698-ba54a5c0bb96" Name="Main Process">
      <ProcessHeader>
        <Created>2015-10-24T16:32:07.7190034-03:00</Created>
        <Description />
      </ProcessHeader>
      <RedefinableHeader>
        <Author />
        <Version />
        <Countrykey>CO</Countrykey>
      </RedefinableHeader>
      <ActivitySets />
      <DataInputOutputs />
      <ExtendedAttributes>
        <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;processClassProperties&quot;:{&quot;displayName&quot;:&quot;Main Process&quot;,&quot;accessType&quot;:&quot;Process&quot;,&quot;enableAlarms&quot;:false,&quot;enableNotifications&quot;:false},&quot;processProperties&quot;:{&quot;globalFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;summaryFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;mobileAccess&quot;:true}}" />
      </ExtendedAttributes>
    </WorkflowProcess>
    <WorkflowProcess Id="0f193f2e-eea8-4702-a3a9-f31ab3198aa3" Name="fix-issue">
      <ProcessHeader>
        <Created>2015-10-24T16:32:07.7190034-03:00</Created>
        <Description />
      </ProcessHeader>
      <RedefinableHeader>
        <Author />
        <Version />
        <Countrykey>CO</Countrykey>
      </RedefinableHeader>
      <ActivitySets />
      <DataInputOutputs />
      <Activities>
        <Activity Id="ed05d89b-c585-4ad0-9f24-5dc655402749" Name="start">
          <Description />
          <Event>
            <StartEvent Trigger="None" />
          </Event>
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="30" Width="30" BorderColor="-10311914" FillColor="-1638505">
              <Coordinates XCoordinate="143" YCoordinate="72" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="aa8093d3-1bc3-480a-acf8-4bcb6a14b6a5" Name="analyze-issue">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="276" YCoordinate="57" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="23110288-092a-4633-b6d3-aee28763cee4" Name="report-fixes">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="586" YCoordinate="57" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="10a9288f-4785-4e16-8bd1-1b25ec3071b3" Name="internal-test">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="586" YCoordinate="189" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="a7f0e8a9-c09a-4e21-860a-7ccbdc25cb9e" Name="end">
          <Description />
          <Event>
            <EndEvent Result="None" />
          </Event>
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="30" Width="30" BorderColor="-6750208" FillColor="-1135958">
              <Coordinates XCoordinate="393" YCoordinate="204" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="70d89556-61a0-46a3-b9e9-f0536e1878d9" Name="report-to-architect">
          <Description />
          <Implementation>
            <SubFlow Id="260dacb0-875f-4db1-9346-4185528f1506" />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="147" YCoordinate="189" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes>
            <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;priority&quot;:0,&quot;asynchronousBehavior&quot;:{},&quot;subProcessType&quot;:&quot;None&quot;,&quot;inputMappingType&quot;:&quot;None&quot;,&quot;outputMappingType&quot;:&quot;None&quot;,&quot;exitMode&quot;:&quot;AllTokens&quot;,&quot;multiInstancePropertyGuid&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;groupByAttributesXPath&quot;:&quot;&quot;}" />
          </ExtendedAttributes>
        </Activity>
        <Activity Id="dfcd873a-20dc-483a-a5e4-08397387d383" Name="can fix">
          <Description />
          <Route />
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="40" Width="40" BorderColor="-5855715" FillColor="-52">
              <Coordinates XCoordinate="441" YCoordinate="67" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
      </Activities>
      <Transitions>
        <Transition Id="7e6a750b-7e3a-4a39-8a88-ff7656eb6050" From="ed05d89b-c585-4ad0-9f24-5dc655402749" To="aa8093d3-1bc3-480a-acf8-4bcb6a14b6a5" Name="start-analyze">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="173" YCoordinate="87" />
              <Coordinates XCoordinate="276" YCoordinate="87" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="67005781-0b9d-4e38-b4a5-845d586c8f80" From="dfcd873a-20dc-483a-a5e4-08397387d383" To="23110288-092a-4633-b6d3-aee28763cee4" Name="create-report">
          <Condition Type="CONDITION">
            <Expression>[:form | form developerCanFix = ''yes'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="481" YCoordinate="87" />
              <Coordinates XCoordinate="586" YCoordinate="87" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="9bab740a-0def-470c-a558-b8a26861904a" From="23110288-092a-4633-b6d3-aee28763cee4" To="10a9288f-4785-4e16-8bd1-1b25ec3071b3" Name="do-internal-test">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="631" YCoordinate="117" />
              <Coordinates XCoordinate="631" YCoordinate="189" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="949f62da-2286-4e05-9bbb-e61a3ee957d3" From="10a9288f-4785-4e16-8bd1-1b25ec3071b3" To="a7f0e8a9-c09a-4e21-860a-7ccbdc25cb9e" Name="finish-internal-test">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="586" YCoordinate="219" />
              <Coordinates XCoordinate="423" YCoordinate="219" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="adbad26d-c890-4460-afb7-3d1637c1992e" From="dfcd873a-20dc-483a-a5e4-08397387d383" To="70d89556-61a0-46a3-b9e9-f0536e1878d9" Name="no-fix-report">
          <Condition Type="CONDITION">
            <Expression>[:form | form developerCanFix = ''no'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="461" YCoordinate="107" />
              <Coordinates XCoordinate="461" YCoordinate="148" />
              <Coordinates XCoordinate="192" YCoordinate="148" />
              <Coordinates XCoordinate="192" YCoordinate="189" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="1903c236-7dab-4c63-a09d-7215c553f606" From="70d89556-61a0-46a3-b9e9-f0536e1878d9" To="a7f0e8a9-c09a-4e21-860a-7ccbdc25cb9e" Name="architect-done">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="237" YCoordinate="219" />
              <Coordinates XCoordinate="393" YCoordinate="219" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="f2eb6df7-93a9-4002-a2e9-13084c98e940" From="aa8093d3-1bc3-480a-acf8-4bcb6a14b6a5" To="dfcd873a-20dc-483a-a5e4-08397387d383" Name="evaluate-fix">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="366" YCoordinate="87" />
              <Coordinates XCoordinate="441" YCoordinate="87" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
      </Transitions>
      <ExtendedAttributes>
        <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;processClassProperties&quot;:{&quot;accessType&quot;:&quot;Process&quot;,&quot;enableAlarms&quot;:false,&quot;enableNotifications&quot;:false},&quot;processProperties&quot;:{&quot;globalFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;summaryFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;mobileAccess&quot;:true}}" />
      </ExtendedAttributes>
    </WorkflowProcess>
  </WorkflowProcesses>
  <ExtendedAttributes />
</Package>'! !

!XPDLProcessTemplate class methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 20:28'!
xpdlExample_ProcessReportToArchitect

^'<?xml version="1.0" encoding="utf-8"?>
<Package xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" Id="1924f872-8d80-4df6-b416-1817b8f9c93c" Name="report-to-architect" xmlns="http://www.wfmc.org/2009/XPDL2.2">
  <PackageHeader>
    <XPDLVersion>2.2</XPDLVersion>
    <Vendor>Bizagi Process Modeler.</Vendor>
    <Created>2015-10-10T17:42:36.4909979-03:00</Created>
    <ModificationDate>2015-10-24T16:31:41.8188815-03:00</ModificationDate>
    <Description>report-to-architect</Description>
    <Documentation />
  </PackageHeader>
  <RedefinableHeader>
    <Author>Usuario</Author>
    <Version>1.0</Version>
    <Countrykey>CO</Countrykey>
  </RedefinableHeader>
  <ExternalPackages />
  <Pools>
    <Pool Id="dd453389-40a7-400c-9a21-0bf48ad62b36" Name="Main Process" Process="cc08648d-6618-4fb6-881a-963de0172570" BoundaryVisible="false">
      <Lanes />
      <NodeGraphicsInfos>
        <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="350" Width="700" BorderColor="-16777216" FillColor="-1">
          <Coordinates XCoordinate="30" YCoordinate="30" />
        </NodeGraphicsInfo>
      </NodeGraphicsInfos>
    </Pool>
    <Pool Id="fcd24662-cac6-4f38-a675-690ed8bffb9c" Name="architect-process" Process="260dacb0-875f-4db1-9346-4185528f1506" BoundaryVisible="true">
      <Lanes>
        <Lane Id="9d014f82-8c80-4e75-b6a7-b403baa5174a" Name="architect" ParentPool="fcd24662-cac6-4f38-a675-690ed8bffb9c">
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="282" Width="650" BorderColor="-11513776" FillColor="-1">
              <Coordinates XCoordinate="50" YCoordinate="0" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Lane>
      </Lanes>
      <NodeGraphicsInfos>
        <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="282" Width="700" BorderColor="-16777216" FillColor="-1">
          <Coordinates XCoordinate="28" YCoordinate="29" />
        </NodeGraphicsInfo>
      </NodeGraphicsInfos>
    </Pool>
  </Pools>
  <Associations />
  <Artifacts />
  <WorkflowProcesses>
    <WorkflowProcess Id="cc08648d-6618-4fb6-881a-963de0172570" Name="Main Process">
      <ProcessHeader>
        <Created>2015-10-24T16:32:07.7890502-03:00</Created>
        <Description />
      </ProcessHeader>
      <RedefinableHeader>
        <Author />
        <Version />
        <Countrykey>CO</Countrykey>
      </RedefinableHeader>
      <ActivitySets />
      <DataInputOutputs />
      <ExtendedAttributes>
        <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;processClassProperties&quot;:{&quot;displayName&quot;:&quot;Main Process&quot;,&quot;accessType&quot;:&quot;Process&quot;,&quot;enableAlarms&quot;:false,&quot;enableNotifications&quot;:false},&quot;processProperties&quot;:{&quot;globalFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;summaryFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;mobileAccess&quot;:true}}" />
      </ExtendedAttributes>
    </WorkflowProcess>
    <WorkflowProcess Id="260dacb0-875f-4db1-9346-4185528f1506" Name="architect-process">
      <ProcessHeader>
        <Created>2015-10-24T16:32:07.7890502-03:00</Created>
        <Description />
      </ProcessHeader>
      <RedefinableHeader>
        <Author />
        <Version />
        <Countrykey>CO</Countrykey>
      </RedefinableHeader>
      <ActivitySets />
      <DataInputOutputs />
      <Activities>
        <Activity Id="893fce24-fb1a-4c0f-983b-54c10ff5a374" Name="start">
          <Description />
          <Event>
            <StartEvent Trigger="None" />
          </Event>
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="30" Width="30" BorderColor="-10311914" FillColor="-1638505">
              <Coordinates XCoordinate="126" YCoordinate="78" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="f091a68d-330f-416a-8055-3f54e9d30047" Name="analyze-developer-report">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="293" YCoordinate="63" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="53e7efda-1ff9-48c9-9957-5ddd98dcaff3" Name="has-solution">
          <Description />
          <Route />
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="40" Width="40" BorderColor="-5855715" FillColor="-52">
              <Coordinates XCoordinate="518" YCoordinate="73" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="b0250340-87e3-4475-82d1-c4f8ff9348aa" Name="report-solution">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="295" YCoordinate="234" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="9606869c-fa23-45e7-b1d6-142450b0a10a" Name="report-workaround">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="600" YCoordinate="138" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="b578fd82-c940-40a7-b6ab-9bb9d329d219" Name="end">
          <Description />
          <Event>
            <EndEvent Result="None" />
          </Event>
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="30" Width="30" BorderColor="-6750208" FillColor="-1135958">
              <Coordinates XCoordinate="494" YCoordinate="249" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
      </Activities>
      <Transitions>
        <Transition Id="74073e00-8b7c-43cb-837f-361aac53f568" From="893fce24-fb1a-4c0f-983b-54c10ff5a374" To="f091a68d-330f-416a-8055-3f54e9d30047" Name="start-dev-analysis">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="156" YCoordinate="93" />
              <Coordinates XCoordinate="293" YCoordinate="93" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="1ecf8804-f7f5-4be3-9824-f7447e3f2101" From="f091a68d-330f-416a-8055-3f54e9d30047" To="53e7efda-1ff9-48c9-9957-5ddd98dcaff3" Name="evaluate-a-solution">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="383" YCoordinate="93" />
              <Coordinates XCoordinate="518" YCoordinate="93" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="e6c9a119-9c6b-4a30-b091-13520157cb0e" From="53e7efda-1ff9-48c9-9957-5ddd98dcaff3" To="b0250340-87e3-4475-82d1-c4f8ff9348aa" Name="create-solution">
          <Condition Type="CONDITION">
            <Expression>[:form | form hasSolution = ''yes'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="538" YCoordinate="113" />
              <Coordinates XCoordinate="538" YCoordinate="164.5" />
              <Coordinates XCoordinate="340" YCoordinate="164.5" />
              <Coordinates XCoordinate="340" YCoordinate="234" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="1bdb9bbc-f85f-4ec8-bd0a-79050142f3cd" From="53e7efda-1ff9-48c9-9957-5ddd98dcaff3" To="9606869c-fa23-45e7-b1d6-142450b0a10a" Name="create-workaround">
          <Condition Type="CONDITION">
            <Expression>[:form | form hasSolution = ''no'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="558" YCoordinate="93" />
              <Coordinates XCoordinate="645" YCoordinate="93" />
              <Coordinates XCoordinate="645" YCoordinate="138" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="f63638f4-d2fb-404a-81da-ae30ceab2603" From="b0250340-87e3-4475-82d1-c4f8ff9348aa" To="b578fd82-c940-40a7-b6ab-9bb9d329d219" Name="end-solution">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="385" YCoordinate="264" />
              <Coordinates XCoordinate="494" YCoordinate="264" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="06887fd3-f3de-465c-a79c-d719d6cbaa08" From="9606869c-fa23-45e7-b1d6-142450b0a10a" To="b578fd82-c940-40a7-b6ab-9bb9d329d219" Name="end-workaround">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="662" YCoordinate="198" />
              <Coordinates XCoordinate="662" YCoordinate="264" />
              <Coordinates XCoordinate="524" YCoordinate="264" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
      </Transitions>
      <ExtendedAttributes>
        <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;processClassProperties&quot;:{&quot;accessType&quot;:&quot;Process&quot;,&quot;enableAlarms&quot;:false,&quot;enableNotifications&quot;:false},&quot;processProperties&quot;:{&quot;globalFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;summaryFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;mobileAccess&quot;:true}}" />
      </ExtendedAttributes>
    </WorkflowProcess>
  </WorkflowProcesses>
  <ExtendedAttributes />
</Package>'! !

!XPDLProcessTemplate class methodsFor: 'other' stamp: 'BrunoBB 10/25/2015 20:26'!
xpdlExample_ProcessTestCase

^'<?xml version="1.0" encoding="utf-8"?>
<Package xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" Id="f9e1b674-bcb7-422c-9c50-49390d1e3cfb" Name="test-case" xmlns="http://www.wfmc.org/2009/XPDL2.2">
  <PackageHeader>
    <XPDLVersion>2.2</XPDLVersion>
    <Vendor>Bizagi Process Modeler.</Vendor>
    <Created>2015-10-10T16:11:13.7791404-03:00</Created>
    <ModificationDate>2015-10-24T16:31:42.0615982-03:00</ModificationDate>
    <Description>test-case</Description>
    <Documentation />
  </PackageHeader>
  <RedefinableHeader>
    <Author>Usuario</Author>
    <Version>1.0</Version>
    <Countrykey>CO</Countrykey>
  </RedefinableHeader>
  <ExternalPackages />
  <Pools>
    <Pool Id="b68fc2af-b6b7-4f25-aab5-dafe86796f0a" Name="Main Process" Process="71a0ff46-d937-49a6-ae0f-a14291afbe5d" BoundaryVisible="false">
      <Lanes />
      <NodeGraphicsInfos>
        <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="350" Width="700" BorderColor="-16777216" FillColor="-1">
          <Coordinates XCoordinate="30" YCoordinate="30" />
        </NodeGraphicsInfo>
      </NodeGraphicsInfos>
    </Pool>
    <Pool Id="80699622-c62b-4fa1-8464-570b9fdc95cf" Name="test-case-process" Process="5d349866-3f8e-432e-887e-eee94a0c66fb" BoundaryVisible="true">
      <Lanes>
        <Lane Id="08dc3675-c926-4e14-844b-d828d3cef9c2" Name="tester" ParentPool="80699622-c62b-4fa1-8464-570b9fdc95cf">
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="141" Width="650" BorderColor="-11513776" FillColor="-1">
              <Coordinates XCoordinate="50" YCoordinate="0" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Lane>
        <Lane Id="5e7dbf23-6b47-4341-8abe-8fdecf2fc01a" Name="test-expert" ParentPool="80699622-c62b-4fa1-8464-570b9fdc95cf">
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="135" Width="650" BorderColor="-11513776" FillColor="-1">
              <Coordinates XCoordinate="50" YCoordinate="141" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Lane>
        <Lane Id="13b461de-b265-412f-baa1-44ed46796f4a" Name="developer" ParentPool="80699622-c62b-4fa1-8464-570b9fdc95cf">
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="120.00003051757813" Width="650" BorderColor="-11513776" FillColor="-1">
              <Coordinates XCoordinate="50" YCoordinate="276" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Lane>
      </Lanes>
      <NodeGraphicsInfos>
        <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="396.00003051757813" Width="700" BorderColor="-16777216" FillColor="-1">
          <Coordinates XCoordinate="30" YCoordinate="30" />
        </NodeGraphicsInfo>
      </NodeGraphicsInfos>
    </Pool>
  </Pools>
  <Associations />
  <Artifacts />
  <WorkflowProcesses>
    <WorkflowProcess Id="71a0ff46-d937-49a6-ae0f-a14291afbe5d" Name="Main Process">
      <ProcessHeader>
        <Created>2015-10-24T16:32:07.8019045-03:00</Created>
        <Description />
      </ProcessHeader>
      <RedefinableHeader>
        <Author />
        <Version />
        <Countrykey>CO</Countrykey>
      </RedefinableHeader>
      <ActivitySets />
      <DataInputOutputs />
      <ExtendedAttributes>
        <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;processClassProperties&quot;:{&quot;displayName&quot;:&quot;Main Process&quot;,&quot;accessType&quot;:&quot;Process&quot;,&quot;enableAlarms&quot;:false,&quot;enableNotifications&quot;:false},&quot;processProperties&quot;:{&quot;globalFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;summaryFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;mobileAccess&quot;:true}}" />
      </ExtendedAttributes>
    </WorkflowProcess>
    <WorkflowProcess Id="5d349866-3f8e-432e-887e-eee94a0c66fb" Name="test-case-process">
      <ProcessHeader>
        <Created>2015-10-24T16:32:07.8019045-03:00</Created>
        <Description />
      </ProcessHeader>
      <RedefinableHeader>
        <Author />
        <Version />
        <Countrykey>CO</Countrykey>
      </RedefinableHeader>
      <ActivitySets />
      <DataInputOutputs />
      <Activities>
        <Activity Id="a5c4f59b-8f98-4ee9-8bac-b7feaf8f9486" Name="start">
          <Description />
          <Event>
            <StartEvent Trigger="None" />
          </Event>
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="30" Width="30" BorderColor="-10311914" FillColor="-1638505">
              <Coordinates XCoordinate="127" YCoordinate="224" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="61dd3bd2-cd44-49ec-9292-7dbb961d11a2" Name="end">
          <Description />
          <Event>
            <EndEvent Result="None" />
          </Event>
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="30" Width="30" BorderColor="-6750208" FillColor="-1135958">
              <Coordinates XCoordinate="629" YCoordinate="210.19999694824219" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="bfebb4b0-96bf-4cc3-b0af-ee035a376ac7" Name="test-case">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="234" YCoordinate="209" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="caf25880-c312-4f57-b5d2-30a76003ec41" Name="test-ok">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="599" YCoordinate="54" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="e170b610-a543-438c-90ac-de6a6bb9d7e9" Name="execute-test">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="MultiInstance" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="234" YCoordinate="54" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="c2e6b767-63dc-4952-b137-614349439ae4" Name="analyze-issue-report">
          <Description />
          <Implementation>
            <Task />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="MultiInstance" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="376" YCoordinate="195.19999694824219" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="8d074c00-d99c-4975-93cc-79071176332a" Name="is-issue">
          <Description />
          <Route />
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="40" Width="40" BorderColor="-5855715" FillColor="-52">
              <Coordinates XCoordinate="455" YCoordinate="64" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
        <Activity Id="fdd455c5-d6cf-494f-bb9c-cf1aedea5d94" Name="fix-issue">
          <Description />
          <Implementation>
            <SubFlow Id="0f193f2e-eea8-4702-a3a9-f31ab3198aa3" />
          </Implementation>
          <Performers />
          <Documentation />
          <Loop LoopType="None" />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="60" Width="90" BorderColor="-16553830" FillColor="-1249281">
              <Coordinates XCoordinate="334" YCoordinate="336" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes>
            <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;priority&quot;:0,&quot;asynchronousBehavior&quot;:{},&quot;subProcessType&quot;:&quot;None&quot;,&quot;inputMappingType&quot;:&quot;None&quot;,&quot;outputMappingType&quot;:&quot;None&quot;,&quot;exitMode&quot;:&quot;AllTokens&quot;,&quot;multiInstancePropertyGuid&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;groupByAttributesXPath&quot;:&quot;&quot;}" />
          </ExtendedAttributes>
        </Activity>
        <Activity Id="2a43f725-58bd-45a8-b456-5da85c4faf32" Name="accept-issue">
          <Description />
          <Route />
          <Documentation />
          <NodeGraphicsInfos>
            <NodeGraphicsInfo ToolId="BizAgi_Process_Modeler" Height="40" Width="40" BorderColor="-5855715" FillColor="-52">
              <Coordinates XCoordinate="541" YCoordinate="243" />
            </NodeGraphicsInfo>
          </NodeGraphicsInfos>
          <ExtendedAttributes />
        </Activity>
      </Activities>
      <Transitions>
        <Transition Id="f9d3a6e6-af6b-46dc-9fcc-c1c2f97b3271" From="a5c4f59b-8f98-4ee9-8bac-b7feaf8f9486" To="bfebb4b0-96bf-4cc3-b0af-ee035a376ac7" Name="start-case">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="157" YCoordinate="239" />
              <Coordinates XCoordinate="234" YCoordinate="239" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="04ee69b1-afd5-4e5c-ad2b-19c999c0b1b6" From="caf25880-c312-4f57-b5d2-30a76003ec41" To="61dd3bd2-cd44-49ec-9292-7dbb961d11a2" Name="test-finished">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="644" YCoordinate="114" />
              <Coordinates XCoordinate="644" YCoordinate="210" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="9137256c-6786-4850-b12d-2b8566694299" From="2a43f725-58bd-45a8-b456-5da85c4faf32" To="61dd3bd2-cd44-49ec-9292-7dbb961d11a2" Name="reject-issue">
          <Condition Type="CONDITION">
            <Expression>[:form | form acceptOrReject = ''reject'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="561" YCoordinate="243" />
              <Coordinates XCoordinate="561" YCoordinate="225" />
              <Coordinates XCoordinate="629" YCoordinate="225" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="9575aef3-2919-455a-8179-2d9a86547aa3" From="2a43f725-58bd-45a8-b456-5da85c4faf32" To="fdd455c5-d6cf-494f-bb9c-cf1aedea5d94" Name="fix">
          <Condition Type="CONDITION">
            <Expression>[:form | form acceptOrReject = ''accept'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="561" YCoordinate="283" />
              <Coordinates XCoordinate="561" YCoordinate="366" />
              <Coordinates XCoordinate="424" YCoordinate="366" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="ec8c36e0-4ae6-4cc1-a5b6-4c459e63fb16" From="fdd455c5-d6cf-494f-bb9c-cf1aedea5d94" To="bfebb4b0-96bf-4cc3-b0af-ee035a376ac7" Name="test-again">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="334" YCoordinate="366" />
              <Coordinates XCoordinate="279" YCoordinate="366" />
              <Coordinates XCoordinate="279" YCoordinate="269" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="536e43b6-c876-4e84-846b-01b2efe43b8b" From="bfebb4b0-96bf-4cc3-b0af-ee035a376ac7" To="e170b610-a543-438c-90ac-de6a6bb9d7e9" Name="run-test">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="279" YCoordinate="209" />
              <Coordinates XCoordinate="279" YCoordinate="114" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="9c75e177-6817-4c98-82b9-db9f481db34a" From="e170b610-a543-438c-90ac-de6a6bb9d7e9" To="8d074c00-d99c-4975-93cc-79071176332a" Name="evaluate-issue">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="324" YCoordinate="84" />
              <Coordinates XCoordinate="455" YCoordinate="84" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="b432225c-69cb-4e5e-9da1-500917b1b7e4" From="8d074c00-d99c-4975-93cc-79071176332a" To="c2e6b767-63dc-4952-b137-614349439ae4" Name="report-issue">
          <Condition Type="CONDITION">
            <Expression>[:form | form result = ''failed'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="475" YCoordinate="104" />
              <Coordinates XCoordinate="475" YCoordinate="149.5" />
              <Coordinates XCoordinate="421" YCoordinate="149.5" />
              <Coordinates XCoordinate="421" YCoordinate="195" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="f50d67c8-61c2-45db-ad73-888d412e5704" From="8d074c00-d99c-4975-93cc-79071176332a" To="caf25880-c312-4f57-b5d2-30a76003ec41" Name="test-ok">
          <Condition Type="CONDITION">
            <Expression>[:form | form result ~= ''failed'']</Expression>
          </Condition>
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="495" YCoordinate="84" />
              <Coordinates XCoordinate="599" YCoordinate="84" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
        <Transition Id="be21efdb-ab66-4603-80ef-3867afd145b3" From="c2e6b767-63dc-4952-b137-614349439ae4" To="2a43f725-58bd-45a8-b456-5da85c4faf32" Name="evaluate-report">
          <Condition />
          <Description />
          <ConnectorGraphicsInfos>
            <ConnectorGraphicsInfo ToolId="BizAgi_Process_Modeler" BorderColor="-16777216">
              <Coordinates XCoordinate="466" YCoordinate="225" />
              <Coordinates XCoordinate="503" YCoordinate="225" />
              <Coordinates XCoordinate="503" YCoordinate="263" />
              <Coordinates XCoordinate="541" YCoordinate="263" />
            </ConnectorGraphicsInfo>
          </ConnectorGraphicsInfos>
          <ExtendedAttributes />
        </Transition>
      </Transitions>
      <ExtendedAttributes>
        <ExtendedAttribute Name="RuntimeProperties" Value="{&quot;processClassProperties&quot;:{&quot;accessType&quot;:&quot;Process&quot;,&quot;enableAlarms&quot;:false,&quot;enableNotifications&quot;:false},&quot;processProperties&quot;:{&quot;globalFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;summaryFormId&quot;:&quot;00000000-0000-0000-0000-000000000000&quot;,&quot;mobileAccess&quot;:true}}" />
      </ExtendedAttributes>
    </WorkflowProcess>
  </WorkflowProcesses>
  <ExtendedAttributes />
</Package>'! !

Object subclass: #XPDLReader2
	instanceVariableNames: 'xpdlDocuments xpdlPools'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

XPDLReader2 subclass: #BizagiXPDLReader2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiReader2'!

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:39'!
exampleMultipleProcesses

		^(XPDLReader2 for: 'TestCase' withString: XPDLProcessTemplate xpdlExample_ProcessTestCase)
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessTemplate xpdlExample_ProcessFixIssue) namedAs: 'FixIssue';
				addXPDLDocument: (XMLDOMParser parse: XPDLProcessTemplate xpdlExample_ProcessReportToArchitect) namedAs: 'ReportToArchitect';
				yourself! !

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:39'!
for: processName withString: xmlString 

	^super new initialize
		addXPDLDocument: (XMLDOMParser parse: xmlString) namedAs: processName;
		yourself! !

!XPDLReader2 class methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:39'!
forFiles: pathFileCollection
	| reader file contents |

	pathFileCollection isEmpty ifTrue: [^super new initialize].

	file:= FileStream fileNamed: pathFileCollection first.
	contents := file contents.
	file close.
	reader for: pathFileCollection first withString: contents.

	pathFileCollection allButFirst do:[:each |
		file:= FileStream fileNamed: each.
		contents := file contents.
		file close.
		reader addXPDLDocument: (XMLDOMParser parse: contents) namedAs: each].

	^self! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:27'!
addXPDLDocument: xpdlDocument namedAs: xpdlName
	"Add a collection of processes contained in <xpdlDocument> to the receiver"
	| pools |

	xpdlDocuments at: xpdlName put: xpdlDocument.

	pools := OrderedCollection new.
	xpdlDocument allElementsNamed: 'Pool' do: [:eachPool | | newPool |
		((eachPool attributeAt: 'Name') = 'Main Process') "this represent the main sheet in Bizagi"
		ifFalse: [newPool := XPDLPoolNode new
										xmlSegment: eachPool;
										id: (eachPool attributeAt: 'Id');
										name: (eachPool attributeAt: 'Name');
										workflowId: (eachPool attributeAt: 'Process');
										yourself.
					newPool 
						createLanes;
						createWorkflowFrom: xpdlDocument;
						setLanesComponents.
					xpdlPools at: newPool getName put: newPool.
		].
	].! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:39'!
getPackageNodeOn: aXMLDocument
	| xmlNodes |

	xmlNodes := aXMLDocument allElementsNamed: 'Package'.
	xmlNodes isEmpty ifTrue: [^nil].

	^xmlNodes first! !

!XPDLReader2 methodsFor: 'searching' stamp: 'BrunoBB 10/26/2015 10:54'!
getPoolNamed: aString ifNone: aBlock

	^xpdlPools at: aString ifAbsent: aBlock! !

!XPDLReader2 methodsFor: 'searching' stamp: 'BrunoBB 10/26/2015 10:55'!
getWorkflowNamed: aString ifNone: aBlock

	^(self getPoolNamed: aString ifNone: [^nil]) workflow! !

!XPDLReader2 methodsFor: 'other' stamp: 'BrunoBB 10/26/2015 11:39'!
initialize

	super initialize.

	xpdlDocuments := Dictionary new.
	xpdlPools := Dictionary new.! !

!XPDLReader2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 11:39'!
xpdlDocuments
	^xpdlDocuments! !

!XPDLReader2 methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 11:39'!
xpdlDocuments: newValue
	xpdlDocuments := newValue! !

!XPDLReader2 methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 11:39'!
xpdlPools
	^xpdlPools! !

!XPDLReader2 methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 11:39'!
xpdlPools: newValue
	xpdlPools := newValue! !
